// special thanks to Andy Geez <a.geezer@dial.pipex.com>

// Borland C++ 5
#pragma warn -sig


#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <string.h>
#include <dos.h>

//#define _DEBUG

LRESULT CALLBACK WindowFunc( HWND, UINT, WPARAM, LPARAM);
char szWinName[] = "Blade15";

HANDLE  hVxD;
DWORD   cbBytesReturned;

#define w32_find_blade                  1
#define w32_get_device_id               2
#define w32_io_out_byte                 3
#define w32_io_out_word                 4
#define w32_io_out_dword                5
#define w32_io_in_byte                  6
#define w32_io_in_word                  7
#define w32_io_in_dword                 8


int blade_device_id = 0;
DWORD current_htotal = 0;
DWORD current_vtotal = 0;
DWORD start_address = 0;
int current_x = 0;
int current_y = 0;


#define INACTIVE        0
#define SCR_640x480     1
#define SCR_320x240     2
#define SCR_720x480     3
#define SCR_512x384     4
#define SCR_800x600     5
#define SCR_1024x768    6







DWORD current_mode = INACTIVE;


typedef struct {
    int HTotal;
    int HDisp;
    int HBStart;
    int HSStart;
    int HSEnd;
    int HBEnd;
    int VTotal;
    int VDisp;
    int VBStart;
    int VSStart;
    int VSEnd;
    int VBEnd;

    int width;
    int height;
    int hpolarity;
    int vpolarity;
    int doublescan;
    int interlace;
    int interlaceratio;

    long dotclockHz;
    long horzHz;
    long vert001Hz;
} CRTCPARAM;




static CRTCPARAM mode1024x768_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
     1424,1024,1024,1184,1272,1416,   414, 384, 384, 388, 392, 413,

// width height HPlr VPlr DblScn Intrlc Iratio
    1024,   768,   1,   1,     0,     1,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   36011760,  24870,   6000
};


static CRTCPARAM mode800x600_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
     1424, 800, 800,1064,1144,1416,   414, 300, 300, 343, 347, 413,

// width height HPlr VPlr DblScn Intrlc Iratio
     800,   600,   1,   1,     0,     1,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   35414880,  24870,   6000
};



static CRTCPARAM mode720x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
     1424, 720, 720,1024,1104,1416,   414, 240, 240, 313, 317, 413,

// width height HPlr VPlr DblScn Intrlc Iratio
     720,   480,   1,   1,     0,     1,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   35414880,  24870,   6000
};



static CRTCPARAM mode640x480_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
     1424, 640, 640, 976,1056,1416,   414, 240, 240, 313, 317, 413,

// width height HPlr VPlr DblScn Intrlc Iratio
     640,   480,   1,   1,     0,     1,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   35414880,  24870,   6000
};



static CRTCPARAM mode512x384_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      712, 512, 512, 600, 640, 704,   414, 384, 384, 388, 390, 413,

// width height HPlr VPlr DblScn Intrlc Iratio
     512,   384,   1,   1,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   17686080,  24840,   6000
};



static CRTCPARAM mode320x240_60 = {
// HTotal Disp BSta SSta SEnd BEnd VTotal Disp BSta SSta SEnd BEnd
      672, 320, 320, 480, 512, 664,   414, 240, 240, 314, 318, 413,

// width height HPlr VPlr DblScn Intrlc Iratio
     320,   240,   1,   1,     0,     0,     0,

// dotclkHz  horzHz  vertHz(in 0.01)
   16692480,  24840,   6000
};









int DetectBlade(void);

void SetGenericVGARegister(CRTCPARAM *cp);

long CalcDotclock(long Vert001Hz, int HTotal, int VTotal, int interlace);
long CalcHorizontalHz(long dotclockHz, int HTotal);
long CalcVert001Hz(long dotclockHz, int HTotal, int VTotal, int interlace);
void SetHVPolarity(int HPolar, int VPolar);
DWORD BitMov(DWORD dstdata, int dstbitpos, DWORD srcdata, int srcbitpos);
void SetSeqReg(BYTE __idx, BYTE data);
BYTE GetSeqReg(BYTE __idx);
BYTE GetAtrbData(BYTE __idx);
void SetAtrbData(BYTE __idx, BYTE data);
void SetCrtcReg(BYTE __idx, BYTE data);
BYTE GetCrtcReg(BYTE __idx);
int GetSeqDivider(void);

void _outb(int edx, BYTE al);
BYTE _inb(int edx);
void _outw(int edx, WORD ax);
WORD _inw(int edx);
void _outl(int edx, DWORD eax);
DWORD _inl(int edx);

void DisableGenerateSignal(void);
void EnableGenerateSignal(void);

void SetSeqDivider(int div);

void AdjustCenter(CRTCPARAM *cp, int center_x, int center_y);



/* 3C4 */
#define OldNewModeControl 0x0B

#define NewMode2 0x0D
#define NewMode1 0x0E
#define Protection 0x11
#define MCLKLow 0x16
#define MCLKHigh 0x17
#define ClockLow 0x18
#define ClockHigh 0x19

/* 3x4 */

#define InterlacedVsyncAdjust 0x19
#define HorizontalParamOverflow 0x2B

#define Offset 0x13
#define CRTCModuleTest 0x1E
#define CRTHiOrd 0x27
#define AddColReg 0x29
#define PixelBusModeReg 0x38

/* 3CE */

#define MiscInternalControlReg 0x2F



static DWORD REFFREQ  =  14318180;
static DWORD VCO_MAX  = 230000000;
static DWORD VCO_MIN  = 14318180 * 3.5;
static DWORD VCLK_MAX = 230000000;



int setBlade(int mode, int bpp);
static void NewMode(void);
static void UnprotectRegisters(void);

static void SetPixelClockDivider(int d0);

static void SetBladeExtRegister(CRTCPARAM *cp);
static DWORD GetBladeBytesPerLine(void);

#if 0
static void SetBladeBytesPerLine(DWORD d0);
#endif

static void SetBladeInterlace(int flag, CRTCPARAM* cp);

static void SetBladeVClock(int Num, int DeN, int PS, int PCDiv);
static long GetBladeVclkParam(long vclk, int *Num, int *DeN, int *PS, int *PCDiv);

static void SetDoubleScan(int flag);

static void SetHSyncSkewInMisc(int flag);
static void SetDoubleLogicalLineWidth(int flag);

#if 0
static int GetDoubleLogicalLineWidth(void);
#endif

static DWORD GetHTotal(void);
static DWORD GetVTotal(void);

DWORD GetBladeScreenStartAddress(void);
void SetBladeScreenStartAddress(DWORD d0);






void SetGenericVGARegister(CRTCPARAM *cp)
{
        DWORD d0;
        DWORD d1;
        int HDispSkew;
        int HSyncDelay;

        HSyncDelay = 0 & 0x03;
        HDispSkew  = 0 & 0x03;

        // Unlock
        SetCrtcReg(0x11, (BYTE)BitMov(GetCrtcReg(0x11), 7, 0, 0));

        // HTotal
        d0 = cp->HTotal;
        d0 = (d0 / 8) - 5;
        SetCrtcReg(0x00, (BYTE)d0);

        // HDisp
        d0 = cp->HDisp;
        d0 = (d0 / 8) - 1;
        SetCrtcReg(0x01, (BYTE)d0);

        // HBlankStart
        d0 = cp->HBStart;
        d0 = d0 / 8;
        SetCrtcReg(0x02, (BYTE)d0);

        // HBlankEnd
        d0 = cp->HBEnd;
        d0 = d0 / 8;
        d1 = GetCrtcReg(0x03);
        d1 = BitMov(d1, 0, d0, 0);
        d1 = BitMov(d1, 1, d0, 1);
        d1 = BitMov(d1, 2, d0, 2);
        d1 = BitMov(d1, 3, d0, 3);
        d1 = BitMov(d1, 4, d0, 4);
        d1 = BitMov(d1, 5, HDispSkew, 0);       // horizontal disp skew
        d1 = BitMov(d1, 6, HDispSkew, 1);       // horizontal disp skew
        d1 = BitMov(d1, 7, 1, 0);                       // compatible read
        SetCrtcReg(0x03, (BYTE)d1);
        SetCrtcReg(0x05, (BYTE)BitMov(GetCrtcReg(0x05), 7, d0, 5));

        // HSyncStart
        d0 = cp->HSStart;
        d0 = d0 / 8;
        SetCrtcReg(0x04, (BYTE)d0);

        // HSyncEnd
        d0 = cp->HSEnd;
        d0 = d0 / 8;
        d1 = GetCrtcReg(0x05);
        d1 = BitMov(d1, 0, d0, 0);
        d1 = BitMov(d1, 1, d0, 1);
        d1 = BitMov(d1, 2, d0, 2);
        d1 = BitMov(d1, 3, d0, 3);
        d1 = BitMov(d1, 4, d0, 4);
        d1 = BitMov(d1, 5, HSyncDelay, 0);
        d1 = BitMov(d1, 6, HSyncDelay, 1);
        SetCrtcReg(0x05, (BYTE)d1);

        // VTotal
        d0 = cp->VTotal;

        d0 = d0 - 2;
        SetCrtcReg(0x06, (BYTE)d0);
        SetCrtcReg(0x07, (BYTE)BitMov(GetCrtcReg(0x07), 0, d0, 8));
        SetCrtcReg(0x07, (BYTE)BitMov(GetCrtcReg(0x07), 5, d0, 9));

        // VDisp
        d0 = cp->VDisp;
        d0 = d0 - 1;
        SetCrtcReg(0x12, (BYTE)d0);
        SetCrtcReg(0x07, (BYTE)BitMov(GetCrtcReg(0x07), 1, d0, 8));
        SetCrtcReg(0x07, (BYTE)BitMov(GetCrtcReg(0x07), 6, d0, 9));


        // VBlankStart
        d0 = cp->VBStart;
        SetCrtcReg(0x15, (BYTE)d0);
        SetCrtcReg(0x07, (BYTE)BitMov(GetCrtcReg(0x07), 3, d0, 8));
        SetCrtcReg(0x09, (BYTE)BitMov(GetCrtcReg(0x09), 5, d0, 9));

        // VBlankEnd
        d0 = cp->VBEnd;
        SetCrtcReg(0x16, (BYTE)d0);

        // VSyncStart
        d0 = cp->VSStart;
        SetCrtcReg(0x10, (BYTE)d0);
        d1 = (DWORD)GetCrtcReg(0x07);
        d1 = BitMov(d1, 2, d0,  8);  // bit 8
        d1 = BitMov(d1, 7, d0,  9);  // bit 9
        SetCrtcReg(0x07, (BYTE)d1);

        // VSyncEnd
        d0 = cp->VSEnd;
        d0 = d0 & 0x0F;
        d1 = (DWORD)GetCrtcReg(0x11) & 0xF0;
        d1 = d1 | d0;
        SetCrtcReg(0x11, (BYTE)d1);

        // Double Scan Dis.
//        SetCrtcReg(0x09, (BYTE)BitMov(GetCrtcReg(0x09), 7, 0, 0));

}

void AdjustCenter(CRTCPARAM *cp, int center_x, int center_y)
{
    int d0;

    if(center_x < 0){
        if((cp->HSStart + center_x) < (cp->HDisp + 8)){
            d0 = cp->HSStart;
            cp->HSStart = cp->HDisp + 8;
            cp->HSEnd  -= (d0 - cp->HSStart);
        }else{
            cp->HSStart = cp->HSStart + center_x;
            cp->HSEnd   = cp->HSEnd   + center_x;
        }
    }else{
        if((cp->HSEnd + center_x) > (cp->HTotal - 16)){
            d0 = cp->HSEnd;
            cp->HSEnd    = cp->HTotal - 16;
            cp->HSStart += (cp->HSEnd - d0);
        }else{
            cp->HSEnd   = cp->HSEnd   + center_x;
            cp->HSStart = cp->HSStart + center_x;
        }
    }

    if(center_y < 0){
        if((cp->VSStart + center_y) < (cp->VDisp + 1)){
            d0 = cp->VSStart;
            cp->VSStart = cp->VDisp + 1;
            cp->VSEnd  -= (d0 - cp->VSStart);
        }else{
            cp->VSStart = cp->VSStart + center_y;
            cp->VSEnd   = cp->VSEnd   + center_y;
        }
    }else{
        if((cp->VSEnd + center_y) > (cp->VTotal - 2)){
            d0 = cp->VSEnd;
            cp->VSEnd    = cp->VTotal - 2;
            cp->VSStart += (cp->VSEnd - d0);
        }else{
            cp->VSEnd   = cp->VSEnd   + center_y;
            cp->VSStart = cp->VSStart + center_y;
        }
    }
}




long CalcDotclock(long Vert001Hz, int HTotal, int VTotal, int interlace)
{
        double f0;

        f0 = (double)VTotal;
        if(interlace != 0){
                f0 += 0.5;
        }
        f0 = f0 * (double)HTotal;
        f0 = f0 * (double)Vert001Hz;
        f0 = f0 / 100.0;

        return (long)f0;
}

long CalcHorizontalHz(long dotclockHz, int HTotal)
{
        return dotclockHz / HTotal;
}

long CalcVert001Hz(long dotclockHz, int HTotal, int VTotal, int interlace)
{
        double f0;

        f0 = (double)VTotal;
        if(interlace != 0){
                f0 += 0.5;
        }
        f0 = f0 * (double)HTotal;
        f0 = (double)dotclockHz / f0;
        f0 = f0 * 100.0;

        return (long)f0;
}

void SetHVPolarity(int HPolar, int VPolar)
{
        BYTE d0;

        if(HPolar != 0) HPolar = 1;
        if(VPolar != 0) VPolar = 1;

        d0 = _inb(0x3CC);
        d0 = d0 & 0x3F;
        d0 = d0 | (VPolar << 7) | (HPolar << 6);
        _outb(0x3C2, d0);
}

DWORD BitMov(DWORD dstdata, int dstbitpos, DWORD srcdata, int srcbitpos)
{
        DWORD d0;
        DWORD d1;

        d1 = srcdata >> srcbitpos;
        d1 = d1 & 1;
        d0 = dstdata & (~(1 << dstbitpos));
        d1 = d1 << dstbitpos;
        d0 = d0 | d1;

        return d0;
}

void SetSeqReg(BYTE __idx, BYTE data)
{
        _outb(0x3c4, __idx);
        _outb(0x3c5, data);
}

BYTE GetSeqReg(BYTE __idx)
{
        BYTE d0;

        _outb(0x3c4, __idx);
        d0 = _inb(0x3c5);
        return d0;
}

BYTE GetAtrbData(BYTE __idx)
{
    int d0;

    if((_inb(0x3CC) & 0x01) == 0)
        d0 = 0x3BA;
    else
        d0 = 0x3DA;

    _inb(d0);
    _outb(0x3c0, __idx | (1 << 5));
    return _inb(0x3c1);
}

void SetAtrbData(BYTE __idx, BYTE data)
{
    int d0;

    if((_inb(0x3CC) & 0x01) == 0)
        d0 = 0x3BA;
    else
        d0 = 0x3DA;

    _inb(d0);
    _outb(0x3c0, __idx | 0x20);
    _outb(0x3c0, data);
}


int GetCrtcAddress(void)
{
    if((_inb(0x3CC) & 0x01) == 0)
        return 0x3B4;
    else
        return 0x3D4;
}

void SetCrtcReg(BYTE __idx, BYTE data)
{
    _outb(GetCrtcAddress(),    __idx);
    _outb(GetCrtcAddress() + 1, data);
}

BYTE GetCrtcReg(BYTE __idx)
{
    BYTE d0;

    _outb(GetCrtcAddress(), __idx);
    d0 = _inb(GetCrtcAddress() + 1);
    return d0;
}


void _outb(int edx, BYTE al)
{
    DWORD d0[2];

    d0[0] = (DWORD)edx;
    d0[1] = (DWORD)al;
    DeviceIoControl(
            hVxD,
            w32_io_out_byte,
            &d0,   8,
            NULL,  0,
            &cbBytesReturned,
            NULL
    );
}

BYTE _inb(int _edx)
{
    DWORD eax;
    DWORD edx;

    edx = (DWORD)_edx;
    DeviceIoControl(
            hVxD,
            w32_io_in_byte,
            &edx,   4,
            &eax,   4,
            &cbBytesReturned,
            NULL
    );
    return((BYTE)eax);
}

void _outw(int edx, WORD ax)
{
    DWORD d0[2];

    d0[0] = (DWORD)edx;
    d0[1] = (DWORD)ax;
    DeviceIoControl(
            hVxD,
            w32_io_out_word,
            &d0,   8,
            NULL,  0,
            &cbBytesReturned,
            NULL
    );
}

WORD _inw(int _edx)
{
    DWORD eax;
    DWORD edx;

    edx = (DWORD)_edx;
    DeviceIoControl(
            hVxD,
            w32_io_in_word,
            &edx,   4,
            &eax,   4,
            &cbBytesReturned,
            NULL
    );
    return((WORD)eax);
}


void _outl(int edx, DWORD eax)
{
    DWORD d0[2];

    d0[0] = (DWORD)edx;
    d0[1] = eax;
    DeviceIoControl(
            hVxD,
            w32_io_out_dword,
            &d0,   8,
            NULL,  0,
            &cbBytesReturned,
            NULL
    );
}

DWORD _inl(int _edx)
{
    DWORD eax;
    DWORD edx;

    edx = (DWORD)_edx;
    DeviceIoControl(
            hVxD,
            w32_io_in_dword,
            &edx,   4,
            &eax,   4,
            &cbBytesReturned,
            NULL
    );
    return(eax);
}


void DisableGenerateSignal(void)
{
        BYTE d0;

        d0 = GetCrtcReg(0x17);
        d0 = d0 & 0x7F;
        SetCrtcReg(0x17, d0);

}

void EnableGenerateSignal(void)
{
        BYTE d0;

        d0 = GetCrtcReg(0x17);
        d0 = d0 | 0x80;
        SetCrtcReg(0x17, d0);
}

void SetGfxcReg(BYTE __idx, BYTE data)
{
    _outb(0x3ce, __idx);
    _outb(0x3cf, data);
}

BYTE GetGfxcReg(BYTE __idx)
{
    BYTE d0;

    _outb(0x3ce, __idx);
    d0 = _inb(0x3cf);
    return d0;
}



void SetSeqDivider(int d0)
{
    int d1;

    d0 -= 1;
    if(d0 != 0) d0 = 1 << 3;
    d1 = GetSeqReg(0x01) & ~0x08;
    d1 = d1 | d0;
    SetSeqReg(0x01, d1);
}


void SetTextHeight(int height)
{
    BYTE d0;

    height = (height - 1) & 0x1F;
    d0  = GetCrtcReg(0x09) & ~0x1F;
    d0 |= height;
    SetCrtcReg(0x09, d0);
}


// Blade3D code

void CheckHVTotal(int bpp)
{
    if(current_mode != INACTIVE){
        if( (GetHTotal() != current_htotal) || (GetVTotal() != current_vtotal)){
            setBlade(current_mode, bpp);
        }
    }
}

int setBlade(int mode, int bpp)
{
    CRTCPARAM cp;
    int Num;
    int DeN;
    int PS;
    int PCDiv;

#ifdef _DEBUG
    return 0;
#endif


    switch(mode){
        case SCR_640x480:
            cp = mode640x480_60;
            break;
        case SCR_320x240:
            cp = mode320x240_60;
            break;
        case SCR_720x480:
            cp = mode720x480_60;
            break;
        case SCR_512x384:
            cp = mode512x384_60;
            break;
        case SCR_800x600:
            cp = mode800x600_60;
            break;
        case SCR_1024x768:
            cp = mode1024x768_60;
            break;
        default:
            cp = mode640x480_60;
    }
    if(bpp == 32){
        cp.dotclockHz *= 2;
    }

    current_htotal = cp.HTotal;
    current_vtotal = cp.VTotal;
    current_mode = mode;

    NewMode();
    UnprotectRegisters();

    cp.dotclockHz = GetBladeVclkParam(cp.dotclockHz, &Num, &DeN, &PS, &PCDiv);
    cp.vert001Hz  = CalcVert001Hz(cp.dotclockHz, cp.HTotal,
                                  cp.VTotal, cp.interlace);
    cp.horzHz     = CalcHorizontalHz(cp.dotclockHz, cp.HTotal);
    cp.interlaceratio = 100;

    cp.HBStart = cp.HDisp;
    cp.HBEnd   = cp.HSEnd;
    cp.VBStart = cp.VDisp;
    cp.VBEnd   = cp.VSEnd;

    DisableGenerateSignal();
    SetGenericVGARegister(&cp);
    SetBladeExtRegister(&cp);
    SetHSyncSkewInMisc(0);
    SetBladeVClock(Num, DeN, PS, PCDiv);

    EnableGenerateSignal();

    return 1;
}




void SetBladeExtRegister(CRTCPARAM *cp)
{
    BYTE d0;
    int d1;
    int interlaceoffset;

    d1 = (cp->HSStart/8) + (cp->HSEnd/8) - ((cp->HTotal/8) - 5);
    if(d1 < 0) d1 = 0;
    d1 = (d1 * cp->interlaceratio) / 100;
    d1 = d1 / 2;
    interlaceoffset = d1;
    SetCrtcReg(InterlacedVsyncAdjust, (BYTE)(interlaceoffset & 0xFF));

    d0 = GetCrtcReg(HorizontalParamOverflow);
    d0 = BitMov(d0, 0, (cp->HTotal  >> 3) - 5, 9);
    d0 = BitMov(d0, 1, (cp->HDisp   >> 3) - 1, 9);
    d0 = BitMov(d0, 2, interlaceoffset       , 9);
    d0 = BitMov(d0, 3, (cp->HSStart >> 3)    , 9);
    d0 = BitMov(d0, 4, (cp->HBStart >> 3)    , 9);
    SetCrtcReg(HorizontalParamOverflow, d0);

    d0 = GetCrtcReg(CRTHiOrd);
    d0 = BitMov(d0, 3,              1,  0);     // line compare bit 10
    d0 = BitMov(d0, 4, cp->VDisp  - 1, 10);
    d0 = BitMov(d0, 5, cp->VSStart   , 10);
    d0 = BitMov(d0, 6, cp->VBStart   , 10);
    d0 = BitMov(d0, 7, cp->VTotal - 2, 10);
    SetCrtcReg(CRTHiOrd, d0);

    SetTextHeight(1);
    SetDoubleScan(cp->doublescan);
    SetBladeInterlace(cp->interlace, cp);
    SetHVPolarity(cp->hpolarity, cp->vpolarity);
}






static DWORD GetBladeBytesPerLine(void)
{
    DWORD d0;

    d0 = GetCrtcReg(Offset);
    d0 = BitMov(d0, 8, GetCrtcReg(AddColReg), 4);
    d0 = BitMov(d0, 9, GetCrtcReg(AddColReg), 5);
    d0 = d0 << 3;

    return d0;
}

#if 0
static void SetBladeBytesPerLine(DWORD d0)
{
    BYTE d1;

    d0 = d0 >> 3;
    SetCrtcReg(Offset, (BYTE)(d0 & 0xFF));
    d1 = GetCrtcReg(AddColReg);
    d1 = (BYTE)BitMov(d1, 4, d0, 8);
    d1 = (BYTE)BitMov(d1, 5, d0, 9);
    SetCrtcReg(AddColReg, d1);
}
#endif


static void SetDoubleScan(int flag)
{
    if(flag == 0){
        SetCrtcReg(0x09, BitMov(GetCrtcReg(0x09), 7, 0, 0));
    }else{
        SetCrtcReg(0x09, BitMov(GetCrtcReg(0x09), 7, 1, 0));
    }
}

#pragma warn -par
static void SetBladeInterlace(int flag, CRTCPARAM *cp)
{
    BYTE status;

    status = GetCrtcReg(CRTCModuleTest) & 0x04;
    if(flag == 0){
        if(status != 0){
            SetDoubleLogicalLineWidth(0);
            SetCrtcReg(CRTCModuleTest, GetCrtcReg(CRTCModuleTest) & ~0x04);
        }
    }else{
        if(status == 0){
            SetDoubleLogicalLineWidth(1);
            SetCrtcReg(CRTCModuleTest, GetCrtcReg(CRTCModuleTest) | 0x04);
        }
    }
}
#pragma warn +par

static long GetBladeVclkParam(long vclk, int *Num, int *DeN, int *PS, int *PCDiv)
{
    double desfreq;
    double temp;
    double tempdt;
    double dt;
    int n, startn, endn;
    int m, startm, endm;
    int k, startk, endk;
    int pdindex, startpdindex, endpdindex;
    double pd;
    int powerup[4] = { 1, 2, 4, 8 };
    double pdd[4] = {1, 1.5, 2, 4 };
    double pdi[4] = {10, 15, 20, 40 };
    int d0;
    int invalid_n_value[] = {
#if 1
         0,  1,  2,  3,  4,  5,  6,  7,
         9, 10, 11, 12, 13, 14, 15,
        18, 19, 20, 21, 22, 23,
        27, 28, 29, 30, 31,
        36, 37, 38, 39,
        45, 46, 47,
        54, 55,
        63,
#endif
        -1
    };


    if(vclk > (long)VCLK_MAX) vclk = (long)VCLK_MAX;


    startn = 8;
    endn   = 247;
    startm = 2;
    endm   = 61;
    startk = 0;
    endk   = 3;
    startpdindex = 0;
    endpdindex   = 3;

    desfreq = (double)vclk;
    dt = VCLK_MAX;
    *Num = 0;
    *DeN = 0;
    *PS  = 0;
    *PCDiv  = 0;

    for(pdindex = startpdindex; pdindex <= endpdindex; pdindex += 1){
        pd = pdd[pdindex];
        for(k = startk; k <= endk; k += 1){
            for(n = startn; n <= endn; n += 1){
                d0 = 0;
                while(1){
                    if(invalid_n_value[d0] == -1) break;
                    if(invalid_n_value[d0] == n) break;
                    d0 += 1;
                }
                if(invalid_n_value[d0] != -1) continue;
                for(m = startm; m <= endm; m += 1){
                    temp = REFFREQ * ((double)(n + 8) / (double)(m + 2));
                    if(VCO_MIN <= temp && temp <= VCO_MAX){
                        temp = REFFREQ * ((double)(n + 8) / (double)((m + 2) * powerup[k]));
                        temp = temp / pd;
                        tempdt = desfreq - temp;
                        if(tempdt < 0) tempdt *= -1;
                        if(tempdt < dt){
                            *Num = n;
                            *DeN = m;
                            *PS  = k;
                            *PCDiv  = pdi[pdindex];
                            dt = tempdt;
                        }
                    }
                }
            }
        }
    }

    n = (*Num + 8);
    m = (*DeN + 2);
    k = powerup[*PS];
    pd = (double)(*PCDiv) / 10;

//    logerror("Num %3d, DeN %3d, PS %1d, PCDiv %.1lf\n", n, m, k, pd);
//    logerror("%.5lf * (Num/DeN) : %lf\n", (double)REFFREQ/1000000,
//                                (double)REFFREQ/1000000 *(double)n / m);
//    logerror("%.5lf * (Num/DeN)/(PS * PCDiv): %lf\n", (double)REFFREQ/1000000,
//                                (double)REFFREQ/1000000 * (double)n/(m * k * pd));
    vclk = REFFREQ * (double)n/(m * k * pd);
//    logerror("vclk : %lf\n", (double)vclk / 1000000.0);

    return vclk;
}


static void UnprotectRegisters(void)
{
    SetSeqReg(Protection, 0x87);
    SetSeqReg(NewMode1, 0xC0 ^ 0x02);
    SetCrtcReg(CRTCModuleTest, GetCrtcReg(CRTCModuleTest) & 0xBF);
}

static void SetBladeVClock(int Num, int DeN, int PS, int PCDiv)
{
    BYTE d0;
    BYTE d1;
    BYTE d2;

    SetPixelClockDivider(PCDiv);
    SetSeqDivider(1);

    /* N is all 8bits */
    d1 = Num;
    /* M is first 6bits, with K last 2bits */
    d2 = (DeN & 0x3F) | (PS << 6);

    SetSeqReg(ClockLow, d1);
    SetSeqReg(ClockHigh, d2);

    d0 = (_inb(0x3CC) & 0xF3) | 0x08;
    _outb(0x3C2, d0);                           // use vclk2
}

#pragma warn -aus
static void NewMode(void)
{
    BYTE d0;

    d0 = GetSeqReg(OldNewModeControl);
//    logerror("Chip Version %2Xh\n", d0);
}
#pragma warn +aus

static void SetPixelClockDivider(int d0)
{
//
//  d0 = PixelClockDiv * 10
//

    BYTE d1;
    BYTE d2;

    switch(d0){
        case 10:         // div 1
            d1 = 0;
            break;
        case 15:         // div 1.5
            d1 = 3;
            break;
        case 20:         // div 2
            d1 = 1;
            break;
        case 40:         // div 4
            d1 = 2;
            break;
        default:
            d1 = 0;
    }

    d1 = d1 << 1;
    d1 = d1 &  0x06;
    d2 = GetSeqReg(NewMode2);
    d2 = d2 & ~0x06;
    d2 = d2 | d1;
    SetSeqReg(NewMode2, d2);
}

static void SetHSyncSkewInMisc(int flag)
{
    DWORD d0;

    if(flag == 0){
        flag = 1;
    }else{
        flag = 0;       // no skew
    }
    d0 = GetGfxcReg(MiscInternalControlReg);
    d0 = BitMov(d0, 5, flag, 0);
    SetGfxcReg(MiscInternalControlReg, (BYTE)d0);
}

#if 0
static int GetDoubleLogicalLineWidth(void)
{
    DWORD d0;

    d0 = GetGfxcReg(MiscInternalControlReg);
    d0 = d0 >> 2;
    d0 = d0 & 0x01;

    return (int)d0;
}
#endif

static void SetDoubleLogicalLineWidth(int flag)
{
    DWORD d0;

    if(flag != 0) flag = 1;
    d0 = GetGfxcReg(MiscInternalControlReg);
    d0 = BitMov(d0, 2, flag, 0);
    SetGfxcReg(MiscInternalControlReg, (BYTE)d0);
}


DWORD GetBladeScreenStartAddress(void)
{
    DWORD d0;

    d0  = (DWORD)GetCrtcReg(0x0D);
    d0 |= (DWORD)GetCrtcReg(0x0C) << 8;
    d0  = BitMov(d0, 16, GetCrtcReg(CRTCModuleTest), 5);
    d0  = BitMov(d0, 17, GetCrtcReg(CRTHiOrd), 0);
    d0  = BitMov(d0, 18, GetCrtcReg(CRTHiOrd), 1);
    d0  = BitMov(d0, 19, GetCrtcReg(CRTHiOrd), 2);
    d0  = d0 << 2;

    return d0;
}

void SetBladeScreenStartAddress(DWORD d0)
{
    DWORD d1;

    d0 = d0 >> 2;
    SetCrtcReg(0x0D, (BYTE)(d0 & 0xFF));
    SetCrtcReg(0x0C, (BYTE)((d0 >> 8)  & 0xFF));

    d1 = GetCrtcReg(CRTCModuleTest);
    d1 = BitMov(d1, 5, d0, 16);
    SetCrtcReg(CRTCModuleTest, (BYTE)d1);

    d1 = GetCrtcReg(CRTHiOrd);
    d1 = BitMov(d1, 0, d0, 17);
    d1 = BitMov(d1, 1, d0, 18);
    d1 = BitMov(d1, 2, d0, 19);
    SetCrtcReg(CRTHiOrd, (BYTE)d1);
}

void SaveStartPos(void)
{
    start_address = GetBladeScreenStartAddress();
    current_x = 0;
    current_y = 0;
}

void ResetStartPos(void)
{
    current_x = 0;
    current_y = 0;
    SetBladeScreenStartAddress(start_address);
    SetAtrbData(0x13, 0);
}

void MoveStartPos(int x, int y, int bpp)
{
    int d0;
    DWORD d1;

    current_x += x;
    current_y += y;
    if(current_x < 0) current_x = 0;
    if(current_y < 0) current_y = 0;
    if(bpp != 32){
        d0  = current_x & ~0x0007;
        d1  = (bpp / 8) * d0;
        d1 += (DWORD)GetBladeBytesPerLine() * current_y;
        d1 += start_address;
        SetBladeScreenStartAddress(d1);
        d0 = current_x & 0x07;
        SetAtrbData(0x13, (BYTE)d0);
    }else{
        d0  = current_x & ~0x0003;
        d1  = (bpp / 8) * d0;
        d1 += (DWORD)GetBladeBytesPerLine() * current_y;
        d1 += start_address;
        SetBladeScreenStartAddress(d1);
        d0 = current_x & 0x03;
        d0 = d0 * 2;
        SetAtrbData(0x13, (BYTE)d0);
    }
}






static DWORD GetHTotal(void)
{
    DWORD d0;

    d0 = GetCrtcReg(0x00);
    d0 = BitMov(d0, 9, GetCrtcReg(HorizontalParamOverflow), 0);
    d0 += 5;
    d0 *= 8;

    return d0;
}

static DWORD GetVTotal(void)
{
    DWORD d0;
    BYTE d1;

    // Unlock
    SetCrtcReg(0x11, BitMov(GetCrtcReg(0x11), 7, 0, 0));

    d1 = GetCrtcReg(0x03);
    d1 = BitMov(d1, 7, 1, 0);           // compatible read
    SetCrtcReg(0x03, d1);

    d0 = GetCrtcReg(0x06);
    d0 = BitMov(d0, 8, GetCrtcReg(0x07), 0);
    d0 = BitMov(d0, 9, GetCrtcReg(0x07), 5);

    d0 = BitMov(d0, 10, GetCrtcReg(CRTHiOrd), 7);

    d0 += 2;

    return d0;
}





int DetectBlade(void)
{
    DWORD eax;
    BOOL  result;

    blade_device_id = 0;
    result = DeviceIoControl(
                    hVxD,
                    w32_find_blade,
                    NULL,   0,
                    NULL,   0,
                    &cbBytesReturned,
                    NULL
             );
    if(result == TRUE){
        DeviceIoControl(
            hVxD,
            w32_get_device_id,
            NULL,   0,
            &eax,   4,
            &cbBytesReturned,
            NULL
        );
        blade_device_id = (int)eax;

        REFFREQ  =  14318180;
        VCO_MAX  = 230000000;
        VCO_MIN  = (DWORD)(REFFREQ * 3.5);      // It seems that Blade3D still has this limitation
        VCLK_MAX = 230000000;

    }

    return blade_device_id;
}


#define IDM_MENU1   101
#define IDM_MENU2   102
#define IDM_MENU3   103
#define IDM_MENU4   104
#define IDM_MENU5   105
#define IDM_MENU6   106
#define MY_NOTIFYICON   (WM_USER + 32)

NOTIFYICONDATA Icon;
HICON hIconTray;
HICON hBlade15;



int GetCurrentBpp(HWND hwnd)
{
    HDC hdc;
    int d0;

    hdc = GetDC(hwnd);
    d0 = GetDeviceCaps(hdc, BITSPIXEL);
    ReleaseDC(hwnd, hdc);

    return d0;
}

int GetHorzRes(HWND hwnd)
{
    HDC hdc;
    int d0;

    hdc = GetDC(hwnd);
    d0 = GetDeviceCaps(hdc, HORZRES);
    ReleaseDC(hwnd, hdc);

    return d0;
}

int GetVertRes(HWND hwnd)
{
    HDC hdc;
    int d0;

    hdc = GetDC(hwnd);
    d0 = GetDeviceCaps(hdc, VERTRES);
    ReleaseDC(hwnd, hdc);

    return d0;
}



typedef struct{
    char*   option;
    WPARAM  wp;
}WordTable;

WordTable wt[] = {
    { "-640x480",  SCR_640x480 },
    { "-320x240",  SCR_320x240 },
    { "-720x480",  SCR_720x480 },
    { "-512x384",  SCR_512x384 },
    { "-800x600",  SCR_800x600 },
    { "-1024x768", SCR_1024x768 },
    { NULL, 0}
};


BOOL Change640x480(int bpp)
{
    DEVMODE dm;
    int d0;
    BOOL result = FALSE;

    d0 = 0;
    while(1){
        if( EnumDisplaySettings(NULL, d0, &dm) == FALSE ) break;
        if(dm.dmPelsWidth == 640 && dm.dmPelsHeight == 480 && dm.dmBitsPerPel == (DWORD)bpp){
            if(ChangeDisplaySettings(&dm, CDS_UPDATEREGISTRY) == DISP_CHANGE_SUCCESSFUL){
                result = TRUE;
            }
            break;
        }
        d0 += 1;
    }

    return result;
}



#pragma argsused
int WINAPI WinMain( HINSTANCE hThisInst, HINSTANCE hPrevInst,
                    LPSTR lpszArgs, int nWinMode)
{
    HWND hwnd;
    MSG  msg;
    RECT windowrect;
    WNDCLASSEX wcl;
    int d0;
    HWND f;
    WPARAM wParam = 0;

    if( _argc != 1 ){
        d0 = 0;
        while(1){
            if(wt[d0].option == NULL) break;
            if( strcmp(_argv[1], wt[d0].option) == 0 ){
                wParam = wt[d0].wp;
                break;
            }
            d0 += 1;
        }
    }

    f = FindWindow(szWinName, szWinName);
    if(f != NULL){
        if(wParam != 0){
            PostMessage(f, WM_COMMAND, wParam, 0);
        }
        return 0;
    }



    hVxD = CreateFile("\\\\.\\bladeio.VXD", 0, 0, NULL, 0,
                        FILE_FLAG_DELETE_ON_CLOSE, NULL);
    if( hVxD == INVALID_HANDLE_VALUE ) {
        MessageBox(NULL, "bladeio.vxd not found", "blade15", MB_OK);
        return(FALSE);
    }

    d0 = DetectBlade();
    if(d0 == 0){
        MessageBox(NULL, "no Blade3D found", "blade15", MB_OK);
        return(FALSE);
    }


    hBlade15    = LoadIcon(hThisInst, "BLADE24");
    hIconTray   = hBlade15;


    wcl.hInstance = hThisInst;
    wcl.lpszClassName = szWinName;
    wcl.lpfnWndProc = WindowFunc;
    wcl.style = CS_DBLCLKS;
    wcl.cbSize = sizeof(WNDCLASSEX);
    wcl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wcl.hIconSm = LoadIcon(NULL, IDI_WINLOGO);
    wcl.hCursor = LoadCursor(NULL, IDC_ARROW);
    wcl.lpszMenuName = NULL;
    wcl.cbClsExtra = 0;
    wcl.cbWndExtra = 0;
    wcl.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);

    wcl.hIconSm = hIconTray;
    if(!RegisterClassEx(&wcl)) return 0;

    windowrect.top    = 0;
    windowrect.bottom = 0;
    windowrect.left   = 0;
    windowrect.right  = 192;
    AdjustWindowRect(&windowrect,
        WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME,
        FALSE
    );

    hwnd = CreateWindowEx(
        WS_EX_TOOLWINDOW,
        szWinName,
        szWinName,
        WS_POPUP,
        0,
        0,
        1,
        1,
        HWND_DESKTOP,
        NULL,
        hThisInst,
        NULL
    );


    ShowWindow(hwnd, nWinMode);
    UpdateWindow(hwnd);

    Icon.cbSize = sizeof(NOTIFYICONDATA);
    Icon.uID = 1;
    Icon.hWnd = hwnd;
    Icon.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
    Icon.hIcon = hIconTray;
    Icon.uCallbackMessage = MY_NOTIFYICON;
//    lstrcpy(Icon.szTip, "Blade15");
    Shell_NotifyIcon(NIM_ADD, &Icon);

    if(wParam != 0){
        PostMessage(hwnd, WM_COMMAND, wParam, 0);
    }

    while(GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    CloseHandle(hVxD);

    return msg.wParam;
}

LRESULT CALLBACK WindowFunc(HWND hwnd, UINT message,
                            WPARAM wParam, LPARAM lParam)
{
    static int  ctrl_pressed  = 0;

    switch(message) {

#pragma warn -aus
        case WM_PAINT:
        {
            HDC hdc;
            PAINTSTRUCT paintstruct;

            CheckHVTotal(GetCurrentBpp(hwnd));
            hdc = BeginPaint(hwnd, &paintstruct);
            EndPaint(hwnd, &paintstruct);
            break;
        }
#pragma warn +aus

        case WM_DISPLAYCHANGE:
            SaveStartPos();
            if( LOWORD(lParam) <= 320 && HIWORD(lParam) <= 240 ){
                setBlade(SCR_320x240, GetCurrentBpp(hwnd));
                lstrcpy(Icon.szTip, "Blade24 320x240");
            }else if( LOWORD(lParam) == 720 && HIWORD(lParam) == 480 ) {
                setBlade(SCR_720x480, GetCurrentBpp(hwnd));
                lstrcpy(Icon.szTip, "Blade24 720x480");
            }else if( LOWORD(lParam) == 512 && HIWORD(lParam) == 384 ) {
                setBlade(SCR_512x384, GetCurrentBpp(hwnd));
                lstrcpy(Icon.szTip, "Blade24 512x384");
            }else if( LOWORD(lParam) == 800 && HIWORD(lParam) == 600 ) {
                setBlade(SCR_800x600, GetCurrentBpp(hwnd));
                lstrcpy(Icon.szTip, "Blade24 800x600");
            }else if( LOWORD(lParam) == 1024 && HIWORD(lParam) == 768 ) {
                setBlade(SCR_1024x768, GetCurrentBpp(hwnd));
                lstrcpy(Icon.szTip, "Blade24 1024x768");
            }else{
                setBlade(SCR_640x480, GetCurrentBpp(hwnd));
                lstrcpy(Icon.szTip, "Blade24 640x480");
            }
            Icon.hIcon = hIconTray;
            Shell_NotifyIcon(NIM_MODIFY, &Icon);
            break;

        case WM_CREATE:
            if(GetHorzRes(hwnd) == 720 && GetVertRes(hwnd) == 480){
                setBlade(SCR_720x480, GetCurrentBpp(hwnd));
                lstrcpy(Icon.szTip, "Blade15 720x480");
            }else if(GetHorzRes(hwnd) == 800 && GetVertRes(hwnd) == 600){
                setBlade(SCR_800x600, GetCurrentBpp(hwnd));
                lstrcpy(Icon.szTip, "Blade15 8000x600");
            }else if(GetHorzRes(hwnd) == 1024 && GetVertRes(hwnd) == 768){
                setBlade(SCR_1024x768, GetCurrentBpp(hwnd));
                lstrcpy(Icon.szTip, "Blade15 1024x768");
            }else{
                setBlade(SCR_640x480, GetCurrentBpp(hwnd));
                lstrcpy(Icon.szTip, "Blade15 640x480");
            }
            break;

        case WM_LBUTTONDBLCLK:
            lstrcpy(Icon.szTip, "Blade15 640x480");
            Icon.hIcon = hIconTray;
            Shell_NotifyIcon(NIM_MODIFY, &Icon);
            Change640x480(GetCurrentBpp(hwnd));
            setBlade(SCR_640x480, GetCurrentBpp(hwnd));
            ResetStartPos();
            break;

        case MY_NOTIFYICON:
            switch(lParam){
                case WM_RBUTTONDOWN:
                {
                    HMENU hFloating;
                    POINT CursorPos;

                    hFloating = CreatePopupMenu();

                    AppendMenu(hFloating, MF_ENABLED, SCR_1024x768, "1024x768");
                    AppendMenu(hFloating, MF_ENABLED, SCR_800x600,  "800x600");
                    AppendMenu(hFloating, MF_ENABLED, SCR_640x480,  "640x480");
                    AppendMenu(hFloating, MF_ENABLED, SCR_512x384,  "512x384");
                    AppendMenu(hFloating, MF_ENABLED, SCR_320x240,  "320x240");
                    AppendMenu(hFloating, MF_SEPARATOR, 0, NULL);
                    AppendMenu(hFloating, MF_ENABLED, SCR_720x480,  "720x480");
                    AppendMenu(hFloating, MF_SEPARATOR, 0, NULL);

                    AppendMenu(hFloating, MF_ENABLED, IDM_MENU1,
                            "E&xit");
                    SetForegroundWindow(hwnd);
                    GetCursorPos(&CursorPos);
                    TrackPopupMenuEx(hFloating, TPM_VERTICAL | TPM_RIGHTBUTTON
                            | TPM_HORIZONTAL,
                            CursorPos.x, CursorPos.y, hwnd, NULL);
                    DestroyMenu(hFloating);
                    break;
                }
            }
            break;

        case WM_COMMAND:
            switch ( GET_WM_COMMAND_ID(wParam, lParam) ) {
                case IDM_MENU1:     // exit
                    PostMessage(hwnd, WM_CLOSE, 0, 0);
                    break;
                case SCR_640x480:
                    setBlade(SCR_640x480, GetCurrentBpp(hwnd));
                    break;
                case SCR_320x240:
                    setBlade(SCR_320x240, GetCurrentBpp(hwnd));
                    break;
                case SCR_720x480:
                    setBlade(SCR_720x480, GetCurrentBpp(hwnd));
                    break;
                case SCR_512x384:
                    setBlade(SCR_512x384, GetCurrentBpp(hwnd));
                    break;
                case SCR_800x600:
                    setBlade(SCR_800x600, GetCurrentBpp(hwnd));
                    break;
                case SCR_1024x768:
                    setBlade(SCR_1024x768, GetCurrentBpp(hwnd));
                    break;
            }
            break;

        case WM_SETFOCUS:
            ctrl_pressed = 0;
            return DefWindowProc(hwnd, message, wParam, lParam);

        case WM_KEYUP:
            if(wParam == VK_CONTROL) ctrl_pressed = 0;
            break;

        case WM_KEYDOWN:
        {
            int dx = 0;
            int dy = 0;

            if(wParam == VK_CONTROL) ctrl_pressed = 1;
            if(wParam == VK_UP)    dy -= 1;
            if(wParam == VK_DOWN)  dy += 1;
            if(wParam == VK_LEFT)  dx -= 1;
            if(wParam == VK_RIGHT) dx += 1;
            if(ctrl_pressed != 0){
                dx = dx * 16;
                dy = dy * 16;
            }
            if(dx != 0 || dy != 0){
                MoveStartPos(dx, dy, GetCurrentBpp(hwnd));
            }
            if(wParam == VK_ESCAPE){
                ResetStartPos();
            }
            break;
        }

        case WM_DESTROY:
            Shell_NotifyIcon(NIM_DELETE, &Icon);
            PostQuitMessage(0);
            break;

        default:
            return DefWindowProc(hwnd, message, wParam, lParam);
    }
    return(0);
}
