.586p

WIN40COMPAT 	equ 	1

.XLIST
include VMM.INC
include VWIN32.INC
.LIST

VER_maj = 0
VER_min = 1
VER = VER_maj*100h+VER_min	; Version No.

; clc + ret
clcret macro
	clc
	ret
	endm

; stc + ret
stcret macro
	stc
	ret
	endm

; Error No. for DEVICEIOCONTROL
ERROR_INVALID_DATA	EQU 0Dh
ERROR_BAD_LENGTH	EQU 18h
ERROR_NOT_SUPPORTED EQU 32h
ERROR_DEV_NOT_EXIST EQU 55


Declare_Virtual_Device bladeio, Ver_maj, Ver_min, CtrlProc, Undefined_Device_ID,,,

VxD_DATA_SEG

vmmName 	db	'VMM	 '

w32_procTable label dword			; address table for Win32 appl (deviceioctrl)
	dd		OFFSET32 w32_find_blade 				; 1
	dd		OFFSET32 w32_get_device_id				; 2
	dd		OFFSET32 w32_io_out_byte				; 3
	dd		OFFSET32 w32_io_out_word				; 4
	dd		OFFSET32 w32_io_out_dword				; 5
	dd		OFFSET32 w32_io_in_byte 				; 6
	dd		OFFSET32 w32_io_in_word 				; 7
	dd		OFFSET32 w32_io_in_dword				; 8

w32_procMax equ ($-w32_procTable)/4 			;


_blade_device_id:
	dd		0

VxD_DATA_ENDS




VxD_CODE_SEG

BeginProc CtrlProc
	Control_Dispatch SYS_DYNAMIC_DEVICE_INIT,dynDevInit
	Control_Dispatch SYS_DYNAMIC_DEVICE_EXIT,dynDevExit
	Control_Dispatch W32_DEVICEIOCONTROL,IOctrl
	clcret
EndProc CtrlProc


BeginProc dynDevInit
	clcret
EndProc dynDevInit


BeginProc dynDevExit
	clcret
EndProc dynDevExit









BeginProc IOctrl
	cmp 	ecx, DIOC_OPEN
	je		IOctrl_ok_ret
	cmp 	ecx, DIOC_CLOSEHANDLE
	je		IOctrl_ok_ret
	dec 	ecx
	cmp 	ecx, w32_procMax
	jae 	IOctrl_ns_error_ret
	call	w32_procTable[ecx*4]
	jc		IOctrl_error_ret

IOctrl_ok_ret:
	xor 	eax, eax
	clcret
IOctrl_ns_error_ret:
	mov 	eax, ERROR_NOT_SUPPORTED
IOctrl_error_ret:
	stcret
EndProc IOctrl



BeginProc w32_find_blade
	call	detect_blade
	test	eax, eax
	je		@f
	mov 	dword ptr[_blade_device_id], eax
	clcret
@@:
	mov 	eax, ERROR_DEV_NOT_EXIST
	stcret
endProc w32_find_blade




BeginProc detect_blade
;
;	out 	eax 	0 or device_id
;
	push	ebx
	push	ecx
	push	edx
	push	esi
	push	edi
	cli

	mov 	esi, 0
	mov 	eax, 0B102h 				; Find Device
	mov 	ecx, 09880h 				; Device ID 	Blade3D
	mov 	edx, 01023h 				; Vender ID 	Trident
	push	01Ah
	VMMcall Exec_VXD_Int
	test	ah, ah
	jz		detect_blade_found
	jmp 	detect_blade_err

detect_blade_found:
	mov 	eax, ecx
	jmp 	detect_blade_ret

detect_blade_err:
	xor 	eax, eax

detect_blade_ret:
	sti
	pop 	edi
	pop 	esi
	pop 	edx
	pop 	ecx
	pop 	ebx
	ret
EndProc detect_blade


BeginProc w32_get_device_id
	cmp 	dword ptr[esi].cbOutBuffer, 4
	jne 	@f
	mov 	ecx, dword ptr[esi].lpvOutBuffer
	cmp 	ecx, 0
	je		@f

	mov 	eax, dword ptr[_blade_device_id]
	mov 	dword ptr[ecx], eax

	mov 	ebx, dword ptr[esi].lpcbBytesReturned
	cmp 	ebx, 0
	je		@f
	mov 	dword ptr[ebx], 4
	clcret
@@:
	mov 	eax, 1
	stcret
EndProc w32_get_device_id





BeginProc w32_io_out_byte
	cmp 	dword ptr[esi].cbInBuffer, 8
	jne 	@f
	mov 	ebx, dword ptr[esi].lpvInBuffer
	cmp 	ebx, 0
	je		@f
	mov 	edx, dword ptr[ebx]
	mov 	eax, dword ptr[ebx + 4]
	out 	dx, al
	clcret
@@:
	mov 	eax, 1
	stcret
EndProc w32_io_out_byte

BeginProc w32_io_out_word
	cmp 	dword ptr[esi].cbInBuffer, 8
	jne 	@f
	mov 	ebx, dword ptr[esi].lpvInBuffer
	cmp 	ebx, 0
	je		@f
	mov 	edx, dword ptr[ebx]
	mov 	eax, dword ptr[ebx + 4]
	out 	dx, ax
	clcret
@@:
	mov 	eax, 1
	stcret
EndProc w32_io_out_word

BeginProc w32_io_out_dword
	cmp 	dword ptr[esi].cbInBuffer, 8
	jne 	@f
	mov 	ebx, dword ptr[esi].lpvInBuffer
	cmp 	ebx, 0
	je		@f
	mov 	edx, dword ptr[ebx]
	mov 	eax, dword ptr[ebx + 4]
	out 	dx, eax
	clcret
@@:
	mov 	eax, 1
	stcret
EndProc w32_io_out_dword



BeginProc w32_io_in_byte
	cmp 	dword ptr[esi].cbOutBuffer, 4
	jne 	@f
	cmp 	dword ptr[esi].cbInBuffer, 4
	jne 	@f
	mov 	ebx, dword ptr[esi].lpvInBuffer
	cmp 	ebx, 0
	je		@f
	mov 	ecx, dword ptr[esi].lpvOutBuffer
	cmp 	ecx, 0
	je		@f

	xor 	eax, eax
	mov 	edx, dword ptr[ebx]
	in		al, dx
	mov 	dword ptr[ecx], eax

	mov 	ebx, dword ptr[esi].lpcbBytesReturned
	cmp 	ebx, 0
	je		@f
	mov 	dword ptr[ebx], 4
	clcret
@@:
	mov 	eax, 1
	stcret
EndProc w32_io_in_byte

BeginProc w32_io_in_word
	cmp 	dword ptr[esi].cbOutBuffer, 4
	jne 	@f
	cmp 	dword ptr[esi].cbInBuffer, 4
	jne 	@f
	mov 	ebx, dword ptr[esi].lpvInBuffer
	cmp 	ebx, 0
	je		@f
	mov 	ecx, dword ptr[esi].lpvOutBuffer
	cmp 	ecx, 0
	je		@f

	xor 	eax, eax
	mov 	edx, dword ptr[ebx]
	in		ax, dx
	mov 	dword ptr[ecx], eax

	mov 	ebx, dword ptr[esi].lpcbBytesReturned
	cmp 	ebx, 0
	je		@f
	mov 	dword ptr[ebx], 4
	clcret
@@:
	mov 	eax, 1
	stcret
EndProc w32_io_in_word

BeginProc w32_io_in_dword
	cmp 	dword ptr[esi].cbOutBuffer, 4
	jne 	@f
	cmp 	dword ptr[esi].cbInBuffer, 4
	jne 	@f
	mov 	ebx, dword ptr[esi].lpvInBuffer
	cmp 	ebx, 0
	je		@f
	mov 	ecx, dword ptr[esi].lpvOutBuffer
	cmp 	ecx, 0
	je		@f

	xor 	eax, eax
	mov 	edx, dword ptr[ebx]
	in		eax, dx
	mov 	dword ptr[ecx], eax

	mov 	ebx, dword ptr[esi].lpcbBytesReturned
	cmp 	ebx, 0
	je		@f
	mov 	dword ptr[ebx], 4
	clcret
@@:
	mov 	eax, 1
	stcret
EndProc w32_io_in_dword




VxD_CODE_ENDS

	end
